-- -------------------------------------------------------------------------- --
-- TradeSkillClearButton by kunda                                             --
-- -------------------------------------------------------------------------- --

local TradeSkillClearButton = CreateFrame("Button", nil, UIParent)

local function ChangeAlpha()
	local text = TradeSkillFrameSearchBox:GetText()
	if text == SEARCH or text == "" then
		TradeSkillClearButton.Texture:SetAlpha(0.25)
	else
		TradeSkillClearButton.Texture:SetAlpha(0.75)
	end
end

local function CreateButton()
	TradeSkillClearButton:SetParent(TradeSkillFrameSearchBox)
	TradeSkillClearButton:EnableMouse(true)
	TradeSkillClearButton:SetWidth(18)
	TradeSkillClearButton:SetHeight(18)
	TradeSkillClearButton:SetPoint("RIGHT", TradeSkillFrameSearchBox, "RIGHT", 0, 0)

	TradeSkillClearButton.Texture = TradeSkillClearButton:CreateTexture(nil, "ARTWORK")
	TradeSkillClearButton.Texture:SetWidth(18)
	TradeSkillClearButton.Texture:SetHeight(18)
	TradeSkillClearButton.Texture:SetPoint("CENTER", 0, 0)
	TradeSkillClearButton.Texture:SetAlpha(0.25)
	TradeSkillClearButton.Texture:SetTexture("Interface\\FriendsFrame\\ClearBroadcastIcon")

	TradeSkillClearButton:SetScript("OnEnter", function()
		local text = TradeSkillFrameSearchBox:GetText()
		if text == SEARCH or text == "" then return end
		TradeSkillClearButton.Texture:SetAlpha(1)
	end)
	TradeSkillClearButton:SetScript("OnLeave", ChangeAlpha)
	
	TradeSkillClearButton:SetScript("OnClick", function()
		local text = TradeSkillFrameSearchBox:GetText()
		if text == SEARCH or text == "" then return end
		TradeSkillFrameSearchBox:SetText("")
	end)
end

local function OnEvent(self, event, arg1)
	if event == "ADDON_LOADED" then
		if arg1 == "Blizzard_TradeSkillUI" then
			CreateButton()
			TradeSkillFrameSearchBox:HookScript("OnTextChanged", ChangeAlpha)
			TradeSkillClearButton:UnregisterEvent("ADDON_LOADED")
		end
	end
end

TradeSkillClearButton:RegisterEvent("ADDON_LOADED")
TradeSkillClearButton:SetScript("OnEvent", OnEvent)